var assert = require("assert").ok

module.exports = function () {
    var signature = Array.prototype.slice.call(arguments),
        fxn = signature.pop(),
        specials = {
            "array": Array.isArray,
            "buffer": Buffer.isBuffer
        };

    return function () {
        var args = Array.prototype.slice.call(arguments);

        assert(signature
            .slice(0, args.length)
            .every(function (s, i) {
                return (specials[s] ? specials[s].call(null, args[i])
                                    : false )
                    || typeof(args[i]) === s;
            }));

        var results = fxn.apply(this, args);

        assert(signature
            .slice(args.length)
            .every(function (s, i) {
                return (specials[s] ? specials[s].call(null, args[i])
                                    : false )
                    || typeof(args[i]) === s;
            }));

        return results;

    };
};
